#ifdef dDOUBLE
#define dsDrawCapsule  dsDrawCapsuleD
#define dsDrawCylinder dsDrawCylinderD
#define dsDrawBox      dsDrawBoxD
#define dsDrawLine     dsDrawLineD
#define dsDrawSphere   dsDrawSphereD
#endif

#define LINK_NUM 5  // Ћr̃N
#define JT_NUM   5  // Ћr̃WCg 
#define LEG_NUM  2  // r
#define GAIT_NUM 6 // 1eXebvōs

enum link_no {
	HIP_DUMMY,   // 0 ֐ߎtp(2Rx̂ߕKvj
	UPPER_LEG,   // 1 r
	LOWER_LEG,   // 2 r
	ANKLE_DUMMY, // 3 ֐ߎtp(2Rx̂ߕKvj
	FOOT         // 4 
};

enum joint_no {
	HIP_PITCH,   // 0 ֐߃sb`
	HIP_ROLL,    // 1 ֐߃[
	KNEE_PITCH,  // 2 G֐߃sb`
	ANKLE_PITCH, // 3 ֐߃sb`
	ANKLE_ROLL   // 4 ֐߃sb`
};

static dWorldID      world;        // ͊wvZp[h
static dSpaceID      space;        // ՓˌovZpXy[X
static dGeomID       ground;       // n
static dJointGroupID contactgroup; // ڐG_O[v
static dsFunctions   fn;           // `֐

// }CIuWFNg\
typedef struct {
  dBodyID  body;
  dGeomID  geom;
  dJointID joint;
  dReal    m,r,h,x,y,z; // ʁAaAAʒu(x,y,z)
  dReal    lx,ly,lz;    // TCY
} MyObject;

static MyObject leg[LEG_NUM][LINK_NUM],base,bullet,cannon,wall[200];

static dReal  THETA[LEG_NUM][LINK_NUM] = {{0},{0}}; // Xebv̖ڕW֐
static dReal  SX = 0, SY = 0, SZ = 0.65;     // ʒu(x,y,z)sz = 0.61
static dReal  gait[GAIT_NUM][LEG_NUM][JT_NUM] ;  // s̖ڕW֐ߊp
// ֐߂͑nʂƕsɂȂ悤ɐ䂵Ă̂gaitzgȂ

static dReal cannon_angle = 0.0, cannon_elevation = 0.0;

static int wb = 0;
static int WALKING_ON = 0;         

const dReal HIP_DUMMY_LENGTH   = 0.05;    // ֐ߎtpN
const dReal UPPER_LEG_LENGTH   = 0.3;     // r̒
const dReal LOWER_LEG_LENGTH   = 0.3;     // r̒
const dReal ANKLE_DUMMY_LENGTH = 0.00001; // ֐ߎtpN 0.0001
const dReal FOOT_LENGTH        = 0.02;    // ̌
const dReal FOOT_RADIUS        = 0.15;    // ̔a
const dReal LEG_RADIUS         = 0.02;    // r̔a
const dReal BODY_LENGTH        = 0.15;    // ̂̒
const dReal BODY_WIDTH         = 0.25;    // ̂̕
const dReal BODY_HEIGHT        = 0.40;    // ̂̍

